//
//  Created by Lukas Hlavaty on 04.01.17.
//  Copyright (c) 2017 Lukas Hlavaty. All rights reserved.
//
#ifndef GUI_H
#define GUI_H
#include "StrukturyIncl.h"
#include "Player.h"
#include <iostream>
#include <stdlib.h>
#include <vector>
#include <algorithm> //pro funkce remove
#include "Statistika.h"

using namespace std;

class GUI
{
    public:
        GUI();
        virtual ~GUI();

        void vypisPanelPrubezneSkore(Player* p1, Player* p2);
        void vypisHodu(sKostkaPoradi pole[]);
        void vypisNalezenychKombinaci(std::vector<sKombinace> kombinace, std::vector<int> odlozene, int docasne, bool pc);
        void vypisKonecKola(int skoreCelkem, int skoreKolo);
        void vyberkombinace(std::vector<sKombinace> kombinace);
        bool zobrazKolo(std::vector<sKombinace> kombinace, std::vector<int> odlozene, int docasne, bool pc, sKostkaPoradi pole[], Player* p1, Player* p2);
        void vypisChybaZadani();
        void vypisNelzeUkoncitKolo();
        void vypisPridanoOdebrano(bool pridano);
        void vypisChybaNutneVybratKombinaci();
        int pokracovatVHazeni();
        bool jeKombinaceVybrana(int indx);
        void hraDoPlnych();
        void zobrazAnalyzu(std::vector<sKombinace> kombinace, sKostkaPoradi pole[], std::vector<int> odlozene, int indexVybrane, int docasne);
        void pocitacHruKonci();
        void credits();
        void uvitani();
        void vyhra(bool hrac, Player* p1, Player* p2);

        void zmenbarvu(string barva);
        void myPause();

        bool pridejOdeberVyber(int index);
        void resetujVybraneKombinace();
        std::vector<int> vratVybraneKombinace();
    protected:

    private:
        std::vector<int>m_vybraneKombinace;
        Statistika* m_statistika;
};

#endif // GUI_H
