//
//  Created by Lukas Hlavaty on 04.01.17.
//  Copyright (c) 2017 Lukas Hlavaty. All rights reserved.
//
#include "Player.h"

Player::Player()
{
    for (int i=0; i<6; i++){
        m_kostky[i].odloz= false;
        m_kostky[i].ko= new Kostka_full();
        m_polePoslednichHodu[i]= 0;
    }

    m_stavSkore= 0;
}

Player::~Player()
{
    for (int i=0; i<6; i++){
        delete(m_kostky[i].ko);
    }
}

void Player::pripisSkore(int prirustek){
    m_stavSkore= m_stavSkore + prirustek;
    m_tabulkaBodu.push_back(prirustek);
}

int Player::get_stavSkore(){
    return m_stavSkore;
}

void Player::nulujOdlozeni(){
    for (int i=0; i<6; i++)
        m_kostky[i].odloz= false;
}

void Player::hodKostkama(bool newLap){
    if (newLap)
        nulujOdlozeni();

    for (int i=0; i<6; i++){
        if (m_kostky[i].odloz==false)
            m_kostky[i].ko->hodKostkou(newLap);
        else
            m_kostky[i].ko->prazdnyHod();
    }
}

bool Player::odlozKostku(int kolikatou){
    if (kolikatou>=0 && kolikatou<6){
        if (m_kostky[kolikatou].odloz!=true){
            m_kostky[kolikatou].odloz= true;
            return true;
        }
        else{
            return false;
        }
    }
    else{
        return false;
    }
}
//-------------------------------------------------------------------------------------
std::tuple<int, int, int, int, int, int> Player::vratPosledniHodVsechnyKostky(){
    auto mojeTuple= std::make_tuple(m_kostky[0].ko->vratPosledniHodVect(),
                                    m_kostky[1].ko->vratPosledniHodVect(),
                                    m_kostky[2].ko->vratPosledniHodVect(),
                                    m_kostky[3].ko->vratPosledniHodVect(),
                                    m_kostky[4].ko->vratPosledniHodVect(),
                                    m_kostky[5].ko->vratPosledniHodVect());
    return mojeTuple;
}

Player::sSestHodnot Player::test(){
    sSestHodnot hody;
    hody.k1= m_kostky[0].ko->vratPosledniHodVect();
    hody.k2= m_kostky[1].ko->vratPosledniHodVect();
    hody.k3= m_kostky[2].ko->vratPosledniHodVect();
    hody.k4= m_kostky[3].ko->vratPosledniHodVect();
    hody.k5= m_kostky[4].ko->vratPosledniHodVect();
    hody.k6= m_kostky[5].ko->vratPosledniHodVect();
    return hody;
}

int* Player::testX(){
    int* pointer;
    for (int i=0; i<6; i++)
        m_polePoslednichHodu[i]= m_kostky[i].ko->vratPosledniHodVect();
    pointer= m_polePoslednichHodu;
    return pointer;
}

int Player::vratPosledniHodKostky(int poradi){
    if (poradi>=0 && poradi<6)
        return m_kostky[poradi].ko->vratPosledniHodVect();
}
//-------------------------------------------------------------------------------------

void Player::vypisTabulkuSkore(){
    for(int i=0; i<m_tabulkaBodu.size(); i++)
        std::cout<<m_tabulkaBodu[i]<<std::endl;

    std::cout<<"---------"<<std::endl;
    std::cout<<m_stavSkore<<std::endl;
}

void Player::vypisHodyVse(){
    int pocKol= m_kostky[0].ko->vratPocetKolVect();

    for (int i=0; i<pocKol; i++){   //pro kazdy kolo
        std::cout<<"Kolo: "<<i+1<<std::endl;
        for (int j=0; j<m_kostky[0].ko->vratPocetHoduVect(i) ; j++){    //pro kazdy hod v kole i
            for (int k=0; k<6; k++){    //pro kazdkou kostku
                int pom= m_kostky[k].ko->vratKonkretniHod(i,j);
                if (pom > 0)
                    std::cout<<pom<<" ";
                else
                    std::cout<<"  ";
            }
            std::cout<<std::endl;
        }

    }
}
